<?php

namespace Drupal\blackbaud_sky_api\Routing;

use Symfony\Component\Routing\Route;

/**
 * Defines a route subscriber to register a url for serving image styles.
 */
class BlackbaudRoutes {

  /**
   * Returns an array of route objects.
   *
   * @return \Symfony\Component\Routing\Route[]
   *   An array of route objects.
   */
  public function routes() {
    $routes = [];

    // Grab the Config form option or the constant for the path.
    $path = \Drupal::config('blackbaud_sky_api.settings')->get('blackbaud_sky_api_redirect_uri') ?: BLACKBAUD_SKY_API_REDIRECT_URI;

    $routes['blackbaud_sky_api.oauth_redirect_uri'] = new Route(
      '/' . $path,
      [
        '_controller' => '\Drupal\blackbaud_sky_api\Controller\DefaultController::redirectUriCallback',
      ],
      [
        '_access' => 'TRUE',
      ]
    );
    return $routes;
  }

}
